#include "graph.h"
#include "refine.h"
#include "match.h"
#include "util.h"
#include "procedge.h"

void InitialAssign(int *ExecT1,graph_type *TaskG,int nproc,int *Assign){
  
  int *Cluster;
  
  /*
  int *ExecT;
  vertex_type *vlist;
  edge_type *elist;
  int V;
  int i,m,myp,myadj;

  V=TaskG->V;
  vlist=TaskG->vlist;
  elist=TaskG->elist;

  ExecT=(int *)s_malloc(sizeof(int)*(V*nproc+1));
  memcpy(ExecT,ExecT1,sizeof(int)*(V*nproc+1));

  for (i=1;i<=V;++i){
	myp=Assign[i]=BestProc(ExecT,i,nproc,V);
	for (m=vlist[i].start;m<vlist[i].end;++m){
	   myadj=elist[m].adj;
	   ExecT[(myp-1)*V+myadj]-=elist[m].wgt;
	}
  }
  free(ExecT);*/
  Cluster=(int*)s_malloc(sizeof(int)*(TaskG->V+1));
  if (TaskG->V>0)
    ProcEdge(ExecT1,TaskG,nproc,Cluster,Assign,1);
  free(Cluster);
}


void MlevelAssign(int *ExecT,graph_type *TaskG,int nproc,int *Assign,int *CAssign,int c_option){
  
  int i,m,k,j;
  int V;
  mlevel_graph_type Glist[100];
  int *Assign1,*Assign2,*temp;

  V=TaskG->V;
  Assign1=Assign;
  Assign2=(int*)s_malloc(sizeof(int)*(V+1));
  memset(Assign,0,sizeof(int)*(V+1));
  Glist[0].TaskG=*TaskG;
  Glist[0].ExecT=ExecT;
  Glist[0].Assign=(int*)s_malloc(sizeof(int)*(V+1));
  Coarsen(&(Glist[0]),&(Glist[1]),nproc,c_option);
  i=1;
  while ((i<99)&&(Glist[i].TaskG.V>2*nproc)&&(Glist[i].TaskG.V<(.8*Glist[i-1].TaskG.V))){
    Coarsen(&(Glist[i]),&(Glist[i+1]),nproc,c_option);
	++i;
  }
  /* Initial Partition */
  InitialAssign(Glist[i].ExecT,&(Glist[i].TaskG),nproc,Assign1);
  memcpy(CAssign,Assign1,sizeof(int)*(Glist[i].TaskG.V+1));
   
  for (m=i;m>0;--m){
	memset(Assign2,0,sizeof(int)*(Glist[m-1].TaskG.V+1));
	for (k=1;k<=Glist[m].TaskG.V;++k)
	  for (j=Glist[m].InvMapNdx[k];j<Glist[m].InvMapNdx[k+1];++j){
	    Assign2[Glist[m].InvMap[j]]=CAssign[k];
	  }
	for (k=1;k<=Glist[m-1].TaskG.V;++k){
	  if (Assign2[k]==0)
	    Assign2[k]=Glist[m-1].Assign[k];
	}
	memcpy(CAssign,Assign2,sizeof(int)*(Glist[m-1].TaskG.V+1));
  }
	 
  for (m=i;m>0;--m){
    Refine(Glist[m].ExecT,&(Glist[m].TaskG),Assign1,nproc);
	memset(Assign2,0,sizeof(int)*(Glist[m-1].TaskG.V+1));
	for (k=1;k<=Glist[m].TaskG.V;++k)
	  for (j=Glist[m].InvMapNdx[k];j<Glist[m].InvMapNdx[k+1];++j){
	    Assign2[Glist[m].InvMap[j]]=Assign1[k];
  	  }
	for (k=1;k<=Glist[m-1].TaskG.V;++k){
	  if (Assign2[k]==0)
	    Assign2[k]=Glist[m-1].Assign[k];
	}
	temp=Assign1;
	Assign1=Assign2;
	Assign2=temp;
	free(Glist[m].Assign); 
	free(Glist[m].ExecT);
	free(Glist[m].InvMap);
	free(Glist[m].InvMapNdx);
	free(Glist[m].TaskG.vlist);
	free(Glist[m].TaskG.elist);
  }
  Refine(ExecT,TaskG,Assign1,nproc);
  free(Glist[0].Assign);
  if (Assign1==Assign)
    free(Assign2);
  else{
    memcpy(Assign,Assign1,sizeof(int)*(V+1));
	free(Assign1);
  }
} 


