typedef int weight_type;
typedef struct sort_edge_type_def{
                 int u;
				 int v;
                 weight_type wgt;
			   } sort_edge_type;

typedef struct edge_type_def{
                 int adj;
                 weight_type wgt;
			   } edge_type;
typedef struct vertex_type_def{
                 int start;
				 int end;
			   } vertex_type;
typedef struct graph_type_def{
                 int V;
				 int E;
                 edge_type *elist;
				 vertex_type *vlist;
} graph_type;

typedef struct mlevel_graph_type_def{
                 graph_type  TaskG;
				 int *Assign;
				 int *ExecT;
				 int *InvMap;
				 int *InvMapNdx;
} mlevel_graph_type;
                 
void SortEdges(sort_edge_type *slist,int sedges);
void AllocateGraph(graph_type *G);
void FreeGraph(graph_type *G);
int FindEdge(graph_type *G,int source,int dest);
void DeleteEdge(graph_type *G,int source,int dest);
void Read_Data(int **ExecT,graph_type *TaskG,int *nproc,char *filename);
int FindQuality(int *ExecT,graph_type *TaskG,int *Assign);
int BestProc(int *ExecT,int u,int nproc,int V);
int TogetherBestProc(int *ExecT,int u,int v,int nproc,int V);
int BestExecT(int *ExecT,int u,int nproc,int V);
