#include "graph.h"
#include "util.h"

int main(int argc,char *argv[])
{
     graph_type TaskG;
     int *ExecT;
     int *Assign;
     
     int i;
     int nproc, optval;
     int br, ar;
   
     FILE* afp;
     char tchar[100];
   
   if(argc >= 3)
     {
	Read_Data(&ExecT,&TaskG,&nproc,&optval,argv[2]);
        
	afp = s_fopen(argv[1], "r");
	
	Assign=(int *)s_malloc(sizeof(int)*(TaskG.V+1));
	
	fscanf(afp, "%s", tchar);
	for(i = 1; i <= TaskG.V; i++)
        {  fscanf(afp,"%d", &Assign[i]);
	   printf("%d ", Assign[i]);
	}
	
	br = FindQuality(ExecT,&TaskG,Assign);
	
	fscanf(afp, "%s", tchar);
	for(i = 1; i <= TaskG.V; i++)
	  fscanf(afp,"%d", &Assign[i]);
	ar = FindQuality(ExecT,&TaskG,Assign);
       
	printf("BeforeRefine: %d, AfterRefine: %d\n", br, ar); 
	fclose(afp);
	free(Assign);
     } 
   else
     {
	printf("Usage: %s <assignmentFile> <dataFile>\n", argv[0]);
     } 
}
