#include "graph.h"
#include "util.h"

graph_type TaskG;
int *ExecT;
int *Cost;
int nproc;

void FindCost(int u,int parent){
  
  int i,m,k,temp,myadj,minc;
  

  for (m=TaskG.vlist[u].start;m<TaskG.vlist[u].end;++m){
    myadj=TaskG.elist[m].adj;
	if (myadj!=parent)
	  FindCost(myadj,u);
  }
   for (i=1;i<=nproc;++i)
     {
	Cost[(u-1)*nproc+i]=ExecT[(i-1)*TaskG.V+u];
	for (m=TaskG.vlist[u].start;m<TaskG.vlist[u].end;++m)
	  {
	     myadj=TaskG.elist[m].adj;
	     if (myadj!=parent){
		for (k=1;k<=nproc;++k)
		  {
		     temp=Cost[(myadj-1)*nproc+k];
		     if (k!=i)
		       temp+=TaskG.elist[m].wgt;
		     if ((k==1)||(temp<minc))
		       minc=temp;
		  }
	     }
	     else
	       minc=0;
	     Cost[(u-1)*nproc+i]+=minc;
	  }
     }
}

void main(int argc,char *argv[]){
  int i,minc;

  if (argc==2){
	Read_Data(&ExecT,&TaskG,&nproc,argv[1]);
	Cost=(int*)s_malloc(sizeof(int)*(nproc*(TaskG.V)+1));
	FindCost(1,0);
	for (i=1;i<=nproc;++i){
	  if ((i==1)||(Cost[i]<minc))
	    minc=Cost[i];
	}
	printf("1 : %d\n",minc);
  }
  else{
    printf("Usage  : %s <Data File> \n",argv[0]);
    exit(1);
  } 
}   

